'''
Created on Apr 13, 2011

@author: Panagiotis

Usage: generate_competitor_conflicts.py [options] <similarities> <sim_thres> <sup_thres> <p>

Options
    --help, -h           help
    --seed, -s           seed for random number generator
  
'''

import sys
import getopt
import random

def main(argv):
  if argv is None:
    argv = sys.argv
  try:
    opts, args = getopt.getopt(argv[1:], 'hs:', ['help', 'seed='])
  except getopt.GetoptError as e:
    print str(e)
    print __doc__
    return 1
  if len(args) != 4:
    print __doc__
    return 1
  similarities_fn = args[0]
  sim_thres = float(args[1])
  sup_thres = float(args[2])
  p = float(args[3])
  seed = None
  
  for o, v in opts:
    if o in ['--help', '-h']:
      print __doc__
      return 0
    elif o in ['--seed', '-s']:
      seed = int(v)
  
  random.seed(seed)
  for line in open(similarities_fn):
    ws = line.strip().split()
    advertiser_i = ws[0]
    advertiser_j = ws[1]
    sim = float(ws[2])
    support = int(ws[3])
    if sim >= sim_thres and support >= sup_thres and random.random() < p:
      if random.random() > 0.5:
        advertiser_i, advertiser_j = advertiser_j, advertiser_i 
      print '%s\t%s' % (advertiser_i, advertiser_j)
    

if __name__ == '__main__':
  sys.exit(main(sys.argv))