'''
Created on Jul 25, 2011

@author: Panagiotis
'''

from collections import defaultdict
from operator import itemgetter
from abc import ABCMeta, abstractmethod

class Allocator:
  __metaclass__ = ABCMeta
  '''
  classdocs
  '''

  def __init__(self, advertiser2bid, advertiser2conflicts, rhos, keyword=None):
    self.advertiser2bid = advertiser2bid
    self.m = len(rhos)              # number of slots
    self.n = len(advertiser2bid)    # number of advertisers
    # Make conflicts symmetric
    self.d = 0                      # number of conflicts
    self.advertiser2conflicts = defaultdict(set)
    for aj in advertiser2bid.iterkeys():
      cj = advertiser2conflicts[aj]
      for ak in cj:
        if ak in advertiser2bid:
          self.d += 1
          self.advertiser2conflicts[aj].add(ak)
          self.advertiser2conflicts[ak].add(aj)
    self.rhos = rhos
    
    self.sorted_advertisers = sorted(self.advertiser2bid.iteritems(), key=itemgetter(1), reverse=True)
    self.x_star = None
    self.w_star = None
    self.p_star = None
    self.delta_price = 0.0
    self.delta_winners = 0.0
    
    self.keyword = 0 if keyword is None else keyword
  
  @abstractmethod  
  def allocate_slots(self, A=None, to_price=False):
    pass